const
maxlength = 50;     { Maximun length of the messages in lines }
maxmess = 75;       { Maximun number of msgs per subboard }

type
   messages = record
             sender   :person;            { record describing the }
             recver   :longname;          { TITLEX.bbs files }
             subject  :longname;
             date     :name;
             messno   :integer;   { <- Unique for all msgs, usually last msg + 1}
             pointer  :integer;   { <- pointer to 1st record in MESSX.BBS file}
        end;

  messrec = record                 {records used in the messx.bbs files}
            mtext  : string[80];   {holds text of msgs}
            pmess  : integer;      {hold pointer to next record in msg}
         end;

   sectrec = record                 {describes the titles.cnf file}
             sectname : string[30]; { ie '1. General board' }
             subdir   : string[40]; { subdirectory msg are in }
             sectaccess : byte;     { minimun access level needed to use}
             specaccess : byte;     { special access if any needed to use}
           end;

  sectnames = array[1..maxnumsects] of sectrec;
  messtext  = array[1..maxlength] of line;

var
  sections : sectnames;
  tempmess : messages;
  messagefile: file of messages;
  textfile : file of messrec;
  count: integer;
  messtable: array[0..maxmess] of messages;
  subdir : longname;
  textopen, mailsent,inmail : boolean;
  mailamount : integer;
  mailpos : integer;
  autoreply : boolean;

function back( x : integer):line;
{returns the user defined backspace key x # of times }
var i : integer;
    temp : line;
begin
  temp := '';
  for i := 1 to x do
    temp := temp + bs;
  back := temp;
end;

function findid(password:name):boolean;
{returns true if users password is found and sets idrec to his parms}
  var
    temp:name;
    code, errcode : integer;
    temprec : sysid;
  begin
    assign(idfile, 'IDS.BBS');
    {$I-} reset(idfile) {$I+};
    errcode := ioresult;
    if errcode <> 0 then rewrite(idfile);
    val(copy(password,1,3),usernum,code);
    if ((errcode <> 0) or (code <> 0)) then findid := false
    else begin
      seek(idfile,usernum);
      {$I-} read(idfile,temprec); {$I+}
        if ioresult <> 0 then findid := false
      else begin
        if temprec.pass = password
          then begin
            findid := true;
            idrec := temprec;
          end
          else findid := false;
      end;
    end;
    close(idfile);
  end;

procedure find_name(name:person; var num:integer; var gotit:boolean);
{pass this procedure a username and it will tell you if it was found or not
 and what his user number is }
var
  temprec : sysid;
  found   : byte;
begin
  found := 0;
  num := -1;
  assign(idfile,'IDS.BBS');
  reset(idfile);
  while(found = 0) do
    begin
      num := num + 1;
      {$I-}
      read(idfile,temprec);
      {$I+}
      if ioresult <> 0 then found := 2;
      if temprec.user = name then found := 1;
    end;
  close(idfile);
  gotit := (found = 1);
end;

function namemess(number: integer):line;
{ constructs file name for message data files}
var  temp:name;
  begin
    str(number,temp);
    namemess := sections[number].subdir + 'MESS' + temp + '.BBS';
  end;

function nametitle(number: integer):line;
{ constructs file name for message title files}
var  temp:name;
  begin
    str(number,temp);
    nametitle := sections[number].subdir + 'TITLE' + temp + '.BBS';
  end;

procedure getsections;
{ go out and get the info in titles.cnf}
var
  titlefile :text;
  temp:integer;
 begin
   assign(titlefile,'bbsinfo\titles.cnf');
   reset(titlefile);
   for temp := 1 to numsects do
     begin
       readln(titlefile,sections[temp].sectname);
       readln(titlefile,sections[temp].subdir);
       readln(titlefile,sections[temp].sectaccess,
                        sections[temp].specaccess);
     end;
   close(titlefile);
 end;

procedure listsections;
{list the names of the subboards}
  var
    num,
    loopvar : integer;
  begin
    if cts then
      begin
        canstat := true;
        clearsc;
        lineout('Decks:' + cr + lf);
        for loopvar := 1 to numsects do
            lineout(sections[loopvar].sectname);
        canstat := false;
      end;
  end;

procedure closemess;
{closes the titlesx.bbs file }
  var
    loop: byte;
  begin
    assign(messagefile,nametitle(subboard));
    rewrite(messagefile);
    for loop := 1 to count do
      write(messagefile, messtable[loop]);
    close(messagefile);
    close(textfile);
    textopen := false;
  end;

function searchmess(x:integer):integer;
{ converts the absolute msg number into the relatve msg number}
var i,j : integer;
    found :boolean;
begin
i := 1;
found := false;
While ((not found) and (i <= count)) do
  begin
    if messtable[i].messno >= x
      then begin
        j := i;
        found := true;
      end;
    i := i + 1;
  end;
if x = 0 then j := 0;
if not found then j := count;
searchmess := j;
end;

procedure initmess;
{ opens up a new msg base}
  begin
  if textopen then
    begin
      close(messagefile);
      close(textfile);
    end;
  if cts then begin
    if cts then lineout(cr + lf + 'Getting Messages ...');
    count := 0;
    assign(messagefile, nametitle(subboard));
    {$I-} reset(messagefile) {$I+};
    if IOresult = 0
      then begin
        while not eof(messagefile) do
          begin
            count := count + 1;
            read(messagefile, messtable[count]);
          end
      end else rewrite(messagefile);
      close(messagefile);
      nextmess := count + 1;
      assign (textfile,namemess(subboard));
      {$I-}
      reset(textfile);
      {$I+}
      if IoResult <> 0 then rewrite(textfile);
      lineout('There are ' + itoa(count) +  ' Messages.');
      lineout('Last Msg Read is #' + itoa(searchmess(last_message[subboard])));
      textopen := true;
    end;
  end;

procedure change_decks;
{ gets a new msg base from user, checks for access and calls initmess }
var
  code, tempi: integer;
  temps: string[2];
  prompt : line;
  ok : boolean;
  x,z: byte;
  y: boolean;
begin
  ok := false;
  clearsc;
  lineout(':] Change Decks :]');
  prompt :=  'Which Board (1 - '+ itoa(numsects) + ',? ): ';
  repeat
     temps := getinput(prompt,2,echo);
     val(temps,tempi,code);
     z := tempi;
     if ((code = 0) and (tempi >= 1) and (tempi <= numsects))
       then begin
         x := sections[z].sectaccess;
         y := (((sections[z].specaccess and special_access) > 0) or
                 (sections[z].specaccess = 0))  ;
         if ((access >= x) and (y))
           then begin
            subboard := tempi;
            ok := true;
             initmess;
           end else begin
             stringout('You DON''T have the Access required for ');
             stringout('this Subboard.  See the Co-sysop ');
             lineout('about ACCESS. ');
          end;
       end
       else if temps = '?' then listsections;
   until (ok or (not cts));
end;

procedure header(tabloc: byte);
{prints out msgs header on one line, used by scan and prompt to read next msg}
  var
    temp: line;
  begin
    if nextmess = 1 then lineout('No Msgs Found..')
    else
      if cts then with messtable[tabloc] do
        begin
          str(tabloc,temp);
          stringout('#' + temp + ' ' + subject);
          stringout('/Nailed by:' +  sender);
          lineout('/To:' + recver);
        end;
  end;

procedure destroy(tabloc: byte);
{ destroys the msg in the messx.bbs files}
  var
    loop, I : byte;
    rtext : messrec;
    temparray : array[1..maxlength] of integer;
  begin
    if ((tabloc > 0 ) and cts)
      then begin
        temparray[1] := messtable[tabloc].pointer;
        loop := 1;
        reset(textfile);
        seek(textfile,messtable[tabloc].pointer);
        read(textfile,rtext);
        while (rtext.pmess > 0) do
          begin
            loop := loop + 1;
            temparray[loop] := rtext.pmess;
            seek(textfile,rtext.pmess);
            read(textfile,rtext);
          end;
        reset(textfile);
        rtext.mtext := '';
        rtext.pmess := -1;
        for I := 1 to loop do
          begin
            seek(textfile,temparray[i]);
            write(textfile,rtext);
          end;
        if not inmail
          then begin
            for loop := tabloc + 1 to count do
            messtable[loop-1] := messtable[loop];
            count := count - 1;
            nextmess := nextmess - 1;
            closemess;
          end else begin
            reset(messagefile);
            seek(messagefile,mailpos);
            messtable[tabloc].recver := '***';
            write(messagefile,messtable[tabloc]);
          end;
    end;
  end;

procedure outmess(tabloc:byte);
{ outputs the msg body}
var
  rtext   : messrec;
begin
  canstat := true;
  reset(textfile);
  seek(textfile,messtable[tabloc].pointer);
  read(textfile,rtext);
  stringout(rtext.mtext);
  while ((rtext.pmess > 0) and (cts) and (not cancelled)) do
    begin
      seek(textfile,rtext.pmess);
      read(textfile,rtext);
      stringout(rtext.mtext);
    end;
  canstat := false;
  if not inmail then msg_read := msg_read + 1;
end;

procedure readfile(tabloc: byte);
{outputs the msg header and then calls proc to output body}
  begin
    if cts then begin
      clearsc;
      if inmail
        then lineout('Subject:' + messtable[tabloc].subject)
        else lineout('Msg #' + itoa(tabloc) + ':' + messtable[tabloc].subject);
      lineout('Date Nailed:'+ messtable[tabloc].date);
      lineout('Msg Nailed by:' + messtable[tabloc].sender);
      lineout('Msg to:' + messtable[tabloc].recver);
      lineout(space);
      outmess(tabloc);
      lineout(space);
    end;
  end;

procedure delmessage(x: integer);
{ gets msg number to delete and calls destroy to kill it}
  var
    tabloc: byte;
    temp : person;
    y    : byte;
  begin
    tabloc := x;
    if cts then begin
      if tabloc > 0 then begin
        temp := messtable[tabloc].sender;
        y := pos('#',temp);
        if y > 5 then delete(temp,y-1,2 + length(temp) - y);
        if ((caller = temp) or (access = sysop))
          then begin
            header(tabloc);
            if getcap('Are you sure (Y/N)? ') = 'Y'
              then begin
                destroy(tabloc);
                lineout('Message Obliterated......');
                msg_nailed := msg_nailed - 1;
              end
          end
          else lineout('You can''t delete that message.');
      end
      else lineout('Message not found.');
    end;
  end;

procedure deletex;
  begin
    if cts then delmessage(getint(nextmess - 1, 0, 'Delete: which number? '));
  end;

procedure quickscan;
  var
    loop: byte;
    first: integer;
  begin
    if cts then begin
      first := getint(nextmess - 1, 1, 'Start scan at which number ? ');
      if first > 0 then begin
        clearsc;
        for loop := first to  count do
          if cts and not cancelled
            then header(loop);
      end;
    end;
  end;

procedure readind(x:integer);
  var
   tabloc : byte;
  begin
      if x > count then lineout('Highest Msg is ' + itoa(count))
                    else if x < 1 then lineout('First Message is 1')
                                  else readfile(x);
    last_message[subboard] := messtable[x].messno;
  end;

procedure readall(x:integer);
var inch : char;
begin
   while cts and ((inch <> 'Q') and (x <= count) and (x > 0 )) do
     begin
       cancelled := false;
       lineout(space);
       lineout(space);
       header(x);
       inch := getcap('Read (Y/N/Q) ? ');
       if not (inch in ['N','Q'])
         then begin
           readfile(x);
           last_message[subboard] := messtable[x].messno;
         end;
       x := x + 1;
     end;
 end;

procedure receive;
  var
    temp : string[5];
    code,x:integer;
  begin {receive}
    if cts then begin
      clearsc;
      if not expert then outfile(readmenu);
      repeat
        temp := '';
        lineout(space);
        temp := allcaps(getinput('Read: (1-'+ itoa(count) + ',<Last=' +
                                 itoa(searchmess(last_message[subboard])) +
                                 '>,Q,?) ? ',5,echo));
        val(temp,x,code);
        if ((code = 0) and (temp <>'')) then readind(x);
        if temp = '?' then outfile(readmenu);
        if (temp = '') then readall(searchmess(last_message[subboard]) + 1);
      until (temp = 'Q') or not cts;
    end;
  end;

procedure enter;
{ one large proc that handles input of msgs to regular msg bases and email}
  var
    tabloc: byte;
    messbuff: messtext;
    linenum: byte;
    inch: char;
    notok : boolean;
    formfile: text;

procedure inputstring2(withecho: boolean; width: integer;
                       var maintext,leftover: line );
{ this proc talks to COMPOSE, this is where wordwrap on msg input is done}
var
  temp:    line;
  ch:      char;
  lastspace,
  i, j     : integer;
begin
  lastspace := 0;
  leftover := '';
  temp := maintext;
  repeat
    ch := charin(noecho);
    if (ch = bs)
      then begin
        if length(temp) > 0
          then begin
            temp := copy(temp, 1, length(temp) - 1);
            if withecho
              then begin
                sendout(bs);
                sendout(space);
                sendout(bs);
              end;
          end;
      end
      else begin  { if not a backspace }
        if (ch <> cr) and (length(temp) < width) and ((ch in [tab, space..#126]) or controls)
          then begin
            if ch = tab    { if tab }
              then
                repeat
                  temp := temp + space;
                  lastspace := length(temp);
                  if withecho then sendout(space);
                until (((length(temp) mod 8) = 0) or (length(temp) >= width))or not cts
              else begin
                temp := temp + ch;
                if ch = space then lastspace := length(temp);
                if withecho then sendout(ch);
              end; {else}  { if tab}
          end
          else begin
            temp := temp + ch;
            if ch = space then lastspace := length(temp);
            if withecho then sendout(ch);
            if ch = cr then temp := temp +lnfd;
            if ch = cr then sendout(lf);
          end;
      end;
  until ((ch = cr) or (length(temp) >= width)) or not cts;
  if ((length(temp) >= width) and (ch <> cr)) then
    begin
      j := length(temp);
      if ((lastspace <> 0) and (lastspace <> j))
        then begin
          leftover := copy(temp, lastspace + 1, j - lastspace);
          temp := copy(temp,1,lastspace);
          for i := lastspace to j do
            begin
              sendout(bs);
              sendout(space);
              sendout(bs);
            end;
        end;
      sendout(cr);
      sendout(lf);
    end;
  maintext := temp;
  end;

  procedure sendstring(message : line );
  {charout and sendout needed to be bypassed in order
    to do wordwrap on msg input, so this is here }
  var i : integer;
  begin
    for i := 1 to length(message) do sendout(message[i]);
  end;

  procedure compose(var block: messtext; var linenum: byte);
  { talks to inputstring2, this is where all the action is on msg input}
    var
      temp,temptext,maintext,leftover : line;
    begin
      leftover := '';
      temptext := '';
      maintext := '';
      lineout(cr + lf + 'Enter message text: ' + itoa(maxlength) + ' lines max.');
      lineout('An empty line ends entry. Words will WRAP Automatically.');
      lineout(space);
      if linenum < maxlength then repeat
        linenum := linenum + 1;
        str(linenum:2, temp);
        sendstring(temp + ': ' + temptext );
        inputstring2(echo,width-6,maintext,leftover);
        block[linenum] := maintext;
        temptext := leftover;
        maintext := leftover;
      until  (linenum = maxlength) or (block[linenum] = (cr +lnfd)) or not cts;
      if block[linenum] = (cr + lnfd) then linenum := linenum - 1;
    end;

  procedure list(var block: messtext; first, last: byte);
  { list msg starting at line x }
    var
      loop: byte;
      temp: name;
    begin
      canstat := true;
      if (first > 0) and (last > 0) and cts then begin
        loop := first;
        while (loop <= last) and cts do begin
          str(loop:2, temp);
          stringout(temp + ': ');
          if copy(block[loop],length(block[loop])-1,2) = cr + lnfd
            then stringout(block[loop])
            else lineout(block[loop]);
          loop := loop + 1;
        end;
        lineout(space);
      end;
      canstat := false;
    end;

  procedure delline(var block: messtext; linenum: byte; var maxline: byte);
    var temp: char;
        loop: byte;
    begin
      list(block, linenum, linenum);
      if cts and (linenum > 0) then begin
        temp := getcap('Delete: are you sure (Y/N) ? ');
        if temp = 'Y' then begin
          for loop := linenum+1 to maxline do block[loop-1] := block[loop];
          block[maxline] := '';
          maxline := pred(maxline);
          lineout('Line deleted.');
        end;
      end;
    end;

  procedure edit(var block: messtext; linenum: byte);
    var
      oldstring: line;
      newstring: line;
      posn     : integer;
    begin
      if (linenum > 0) and cts then begin
        list(block, linenum, linenum);
        oldstring := getinput('Enter string to replace: ', width-6, echo);
        newstring := getinput('Enter replacement: ', width-6, echo);
        if (length(newstring) - length(oldstring) + length(block[linenum])) > (width - 6)
          then lineout('New string too long for Current Width')
          else begin
            posn := pos(oldstring, block[linenum]);
            if posn <> 0 then begin
              delete(block[linenum], posn, length(oldstring));
              insert(newstring, block[linenum], posn);
              list(block, linenum, linenum);
            end
            else lineout('Old string not found.');
          end;
        lineout(space);
      end;
    end;

  procedure replace(var block: messtext; linenum: byte);
    begin
      if (linenum > 0) and cts then begin
        lineout('Old line:      ');
        list(block, linenum, linenum);
        lineout('Enter new line:');
        stringout('? ');
        block[linenum] := inputstring(echo,width-6);
        while length(block[linenum]) < 3 do
          block[linenum] := ' ' + block[linenum];
      end;
    end;

  function whichline(linenum: byte): byte;
    var
      temp: name;
      x   : integer;
    begin
      str(linenum:2, temp);
      x := getint(linenum, 0, ' Which line? (1 - ' + temp + ')? ');
      if (x <= 0) or not cts then whichline := 0 else whichline := x;
    end;

overlay procedure newheader(var entry: messages);
  { sorry its a bit long, but it has to handle both email
    and the regular msg bases, inmail is the boolean variable
    that signals if your in e-mail or not }
    var
      temp,x,code : integer;
      ok : boolean;
      temps : integer;
      tempid : sysid;
      ch : char;
      prompt : line;
    begin
      ok := false;
      if cts then begin
        if not inmail
          then begin
            clearsc;
            lineout(':] Nail up a Message :]');
            entry.sender := caller + ' #'+ itoa(usernum);
            lineout('Message Nailed by :'+entry.sender);
            inbuffer := '';
            entry.recver := getinput('To Who? ',25,echo);
            if entry.recver = '' then entry.recver := 'Alfred E. Nueman';
            entry.subject := getinput('Subject (25 characters max.)? ', 25, echo);
            if entry.subject = '' then entry.subject := 'What? Me Worry?';
            clock(year,month, date, hour, min);
            entry.date := time(year, month, date, hour, min);
            lineout('Date Nailed :'+entry.date);
            if (count = 0) then entry.messno := 1
              else entry.messno := messtable[count].messno + 1;
          end
          else begin
            entry.sender := caller;
            notok := true;
            repeat
              if not autoreply
                then begin
                  entry.recver := '';
                  lineout('If You know the user number you');
                  lineout('Can type that in for the Name.');
                  entry.recver := allcaps(getinput('To Who? ',25,echo));
                  val(entry.recver,x,code);
                  if ((code = 0) and (entry.recver <>''))
                    then begin
                      reset(idfile);
                      if ((x > filesize(idfile) - 1) or (x < 0))
                        then lineout('Invalid User Number!!!!')
                        else begin
                          seek(idfile,x);
                          read(idfile,tempid);
                          prompt := 'Send message to '+ tempid.user + '(Y/N)? ';
                          ch := getcap(prompt);
                          if ch = 'Y'
                            then begin
                              entry.recver := tempid.user;
                              ok := true;
                              notok := false;
                            end else notok := true;
                        end;
                      close(idfile);
                    end;
                  if((code <> 0) and (entry.recver <> ''))
                    then begin
                      find_name(entry.recver,temp,ok);
                      if not ok then lineout('Never heard of that Swabbie!');
                      if ok then notok := false;
                    end;
                end else begin
                  clearsc;
                  ok := true;
                  notok := false;
                  lineout('Message from: '+ entry.sender);
                  lineout('Message to  : '+ entry.recver);
                end;
                  if ok then begin
                    entry.subject := getinput('Subject (25 characters max.)? ', 25, echo);
                    clock(year, month, date, hour, min);
                    entry.date := time(year, month, date, hour, min);
                    lineout('Date Nailed :'+entry.date);
                  end;
                  ok := true;
            until ((not cts) or (ok));
          end;
      end;
    end;

overlay procedure storemess(var block: messtext; tabloc, lastline: byte);
  { stores the msg away }
    var
      linenum: byte;
      freearray : array[1..maxlength] of integer;
      i : integer;
      temp : messrec;

  procedure get_next;
  {finds next blank record and stores its location in freearray}
  var i , j ,errcode : integer;
  begin
    errcode := 0;
    i := 0;
    j := 0;
    reset(textfile);
    while ((errcode = 0) and ( i < lastline)) do
      begin
        {$I-}
        read(textfile,temp);
        {$I+}
        errcode := ioresult;
        if ((temp.pmess = -1) and (errcode = 0))
          then begin
            i := i + 1;
            freearray[i] := j;
          end;
        j := j + 1;
      end;
    if i < lastline
      then begin
        if filesize(textfile) = 0 then j := 0
                                  else j := filesize(textfile);
        while (i < lastline) do
          begin
            i := i + 1;
            freearray[i] := j;
            j := j + 1;
          end;
      end;
  end;

procedure compressmess;
{ compresses the msg text so that all 80 bytes are used up in
  the msg record}
var
  current, last, i : integer;
begin
  current := 1 ; last := lastline;
  while current < last do
    begin
      if length(block[current]) < 80
        then begin
          if (length(block[current + 1]) <= (80 - length(block[current])))
            then begin
              block[current] := block[current] + block[current + 1];
              for i := current + 1 to last - 1 do block[i] := block[i + 1];
              last := last -1;
              current := current - 1;
            end
            else begin
              i := length(block[current]);
              block[current] := block[current] + copy(block[current + 1],1,80 - i);
              delete(block[current + 1],1,80 - i);
            end;
        end;
    current := current + 1;
    end;
  lastline := last;
end;

    begin {storemess}
      if inmail then mailsent := true;
      if cts then begin
        if not inmail
          then begin
            lineout('Message will remain on line for 10 minutes.');
            stringout('Nailing Message...'+back(18));
            lineout('Time is Realitive ' + back(18)+'HOLD ON............');
          end
          else lineout('Sending Mail....');
        reset(textfile);
        compressmess;
        get_next;
        linenum := 1;
        messtable[tabloc].pointer := freearray[1];
        while linenum <= lastline do begin
          if linenum = lastline then temp.pmess := 0
                                  else temp.pmess := freearray[linenum+1];
          temp.mtext := block[linenum];
          seek(textfile,freearray[linenum]);
          write(textfile,temp);
          linenum := linenum + 1;
        end;
        if not inmail
          then begin
            messages_posted := messages_posted + 1;
            nextmess := nextmess + 1;
            count := count + 1;
            msg_nailed := msg_nailed + 1;
            closemess;
          end else begin
            seek(messagefile,filesize(messagefile));
            write(messagefile,messtable[1]);
            mail_sent := mail_sent + 1;
          end;
      end;
    end;

  begin
    tabloc := nextmess;
    if cts then begin
      if ((access < reg) and (not inmail))
                        then begin
                           lineout('You cannot enter messages yet!');
                           lineout('Please Wait until your verified');
                         end
      else begin
        if ((tabloc > maxmess) and (not inmail)) then destroy(1);
        if not inmail then tabloc := count + 1 else tabloc := 1;
          repeat
            newheader(messtable[tabloc]);
            if not notok then inch := getcap('Is this OK (Y/N/Abort)? ')
              else inch := 'A';
          until (inch <> 'N') or not cts;
          if inch <> 'A' then begin
            linenum := 0;
            compose(messbuff, linenum);
            if not expert then outfile(editmenu);
            repeat
              inch := getcap('Edit command: A,C,D,E,L,R,S or ? for menu? ');
              case inch of
                'C': compose(messbuff, linenum);
                'D': delline(messbuff, whichline(linenum), linenum);
                'E': edit(messbuff, whichline(linenum));
                'L': list(messbuff, whichline(linenum), linenum);
                'R': replace(messbuff, whichline(linenum));
                'S': storemess(messbuff, tabloc, linenum);
                '?': outfile(editmenu);
              end;
            until (inch = 'A')
               or (inch = 'S')
               or (inch = 'P')
               or not cts;
          end;
        end;  {2nd else}
    end; {if cts}
  end; {enter}

{ start of mail section }

procedure readmine;
{checks to see if you have mail at sign on time}
var stuff : string[50];
    temprec: messages;
  begin
    cancelled := false;
    mailamount := 0;
    if cts
      then begin
        lineout(space);
        lineout('Checking for your mail...');
        assign(messagefile,'TITLE0.BBS');
        {$I-}
        reset(messagefile);
        {$I+}
        if IOresult = 0 then
          while not eof(messagefile) do
            begin
              read(messagefile,temprec);
              if temprec.recver = caller then mailamount := mailamount + 1;
            end
          else rewrite(messagefile);
        case mailamount of
              0  : stuff := 'No mail today... Oh Well....';
              1  : stuff := 'Hey! Look! There is something in there!';
              2  : stuff := 'Getting popular around here arent we?';
              3  : stuff := 'Holy Mailbox Batman!!!';
        4 .. 1000: stuff := 'We''ll have to push the delete button on you!';
        end; {case}
        lineout(stuff);
        if mailamount > 0 then begin
                      lineout('You have ' + itoa(mailamount) + ' Msg(s) Waiting');
                      lineout('Use ''M'' Command to Read');
                    end;
      close(messagefile);
      end;
  end;


procedure sendmail;
begin
  enter;
  autoreply := false;
end;

procedure readmail;
var  temprec : messages;
     ch : char;
begin
  mailpos := 0;
  while ((mailpos < filesize(messagefile)) or (not cts) or (mailamount <>0 ))do
     begin
       reset(messagefile);
       seek(messagefile,mailpos);
       {$I-}
       read(messagefile,temprec);
       {$I+}
       if ioresult <> 0 then exit;
       if temprec.recver = caller
         then begin
           mail_rec := mail_rec + 1;
           mailamount := mailamount - 1;
           messtable[1] := temprec;
           clearsc;
           readfile(1);
           repeat
             lineout(space);
             lineout('R]ead Again:');
             lineout('A]uto Reply:');
             lineout('T]ear-up:');
             ch := getcap('     Which ? ');
             case ch of
               'A' : begin
                       destroy(1);
                       messtable[1].recver := temprec.sender;
                       autoreply := true;
                       sendmail;
                     end;
               'R' : readfile(1);
               'T' : destroy(1);
             end{case};
           until (ch in ['A','T']) or not cts;
         end;
       mailpos := mailpos + 1;
     end;
end;

procedure mail;
var ch : char;
    temp : integer;
begin
  if textopen then closemess;
  inmail := true;
  autoreply := false;
  assign(messagefile,'TITLE0.BBS');
  {$I-}
  reset(messagefile);
  {$I+}
  if IOresult <> 0 then rewrite(messagefile);
  assign(textfile,'MESS0.BBS');
  {$I-}
  reset(textfile);
  {$I+}
  if IOresult <> 0 then rewrite(textfile);
  if cts then
    begin
      temp := subboard;
      ch := 'N';
      clearsc;
      lineout(':] Mail To Other Pirates :]');
      lineout(space);
      if mailamount > 0 then ch := getcap('Want to Read your Mail now ? ');
      if ch = 'Y' then readmail;
      repeat
        if mailsent then ch := getcap('Want to send more Mail ? ')
          else ch := getcap('Want to Send Mail ? ');
        if ch = 'Y' then sendmail;
      until ((ch = 'N') or (not cts));
    end;
      inmail := false;
      close(textfile);
      close(messagefile);
      subboard := temp;
      initmess;
end;

procedure definecs;
  var
    ch: char;
    prompt: line;
  begin
    ch := null;
    while cts and not (ch in ['Q','Y']) do begin
      lineout('The following input is NOT echoed until CR (RETURN) is pressed!');
      prompt := 'Enter character(s) that will clear your screen (end with CR): ';
      controls := true;
      cs := getinput(prompt, 11, noecho);
      controls := false;
      clearsc;
      ch := getcap(cr + lf + 'Did that do it (Y/N/Quit)? ');
    end;
    if ch = 'Q' then cs := cls;
  end;

procedure definebs;
  begin
    repeat
      purgeline;
      controls := true;
      stringout('Type your backspace key: ');
      bs := charin(echo);
      controls := false;
      lineout(space);
    until not ((bs in [cr, tab, space, '0'..'9', 'A'..'Z', 'a'..'z']) and cts);
  end;

procedure setwidth;
  var temp: integer;
  begin
    repeat
      temp := getint(80, 0, 'Enter your terminal width (20 - 80): ');
    until (temp in [0,20..80]) or not cts;
    if temp <> 0 then width := temp;
  end;

procedure setvideo;
  var loop: byte;
      inch: integer;
      temp: name;

  function ctlchar(ch: char): name;
    begin
      if ch > #127 then ch := chr(ord(ch) and 127);
      case ch of
        null..#31   : ctlchar := '^' + chr(ord(ch) + 64);
        space..#126 : ctlchar := ch;
        #127        : ctlchar := '<DEL>';
      end;
    end;

  procedure dispcontrol(ch: char);
    begin
      if ch < #128 then stringout(ctlchar(ch))
        else stringout(ctlchar(ch) + '(with 8th bit set)');
    end;

  begin
    repeat
      clearsc;
      lineout('Terminal parameters:' + cr + lf);
      lineout('1 - Upper case only: ' + yn[caps]);
      lineout('2 - Line feeds sent: ' + yn[lf = lnfd]);
      lineout('3 - Prompt bell ON : ' + yn[bl = bell]);
      stringout('4 - Backspace char.: ');
      dispcontrol(bs);
      lineout(space);
      stringout('5 - Clear Screen   : ');
      for loop := 1 to length(cs) do dispcontrol(cs[loop]);
      lineout(space);
      str(width:3, temp);
      lineout('6 - Terminal width : ' + temp);
      lineout(space);
      inch := getint(6, 0, 'Enter number of parameter to change (0 to quit): ');
      case inch of
        1: caps := not caps;
        2: if lf = lnfd then lf := null else lf := lnfd;
        3: if bl = bell then bl := null else bl := bell;
        4: definebs;
        5: definecs;
        6: setwidth;
      end;
    until (inch = 0) or not cts;
    if cts then lineout('New definitions are saved when you [D]ematerialize.' + cr + lf);
  end;

procedure talk;
var
  inch: char;
begin
  lineout( space );
  lineout('***** PROGRAM INTERRUPTION *****');
  lineout('*** On your KNEES! It''s STARGAZER ***');
  lineout( space );
  while cts and (inch <> abort) do begin
    inch := charin(echo);
    if inch = cr then sendout(lf);
  end;
end;

procedure chat;
  var
    count  : byte;
    inch   : char;
  begin
    update_userlog('*** CHAT ***');
    chatsysop := true;
    inch := null;
    dispcaller;
    clock(year,month,date,hour,min);
    if ((hour > 22) or (hour < 7))
      then lineout(cr + lf + 'Sorry Swab, StarGazer''s hours are from 7am to 10pm'+ cr + lf)
      else begin
           if nochat <> 2
              then lineout('Sorry Swabbie, but StarGazer''s secratary is holding all calls')
              else begin
                lineout(space);
                lineout('Summoning STARGAZER, HE doesn''t like to be bothered. ');
                lineout('YOU better have a good reason!.');
                purgeline;
                lineout( space );
                count := 1;
                repeat
                  case count of
                    1..4 : lineout('StarGazer!');
                    5 : lineout('StarGazer! You There?');
                    6 : lineout( caller + ' Wants to talk to ya!');
                    7 : lineout('Hmmm... I think he''s around.');
                    8 : lineout('STAAAAAARRRRGAAAAAZZZER!!!');
                    9 : lineout('StarGazer some BOZO wants to talk to ya!');
                    10 : lineout('Gee.  I wonder where that lazy bum is...');
                  end; {case}
                count := count + 1;
                xmitchar(bell);
                beep;
                delay(2000);
                if keypressed then read(kbd,inch);
                until (count > 10) or (inch <> null) or (not cts);
                if inch <> null
                then talk
                else lineout(cr + lf + 'Sorry, StarGazer isn''t around right now. ');
            end;
       end;
  end;

procedure newpass;
{get a new password }
  var
    temp   : name;
    prompt : line;
    ch : char;
    ok : boolean;
    dummy : integer;
  begin
    repeat
      find_name(caller,dummy,ok);
      if not ok then usernum := nextuser;
      inbuffer := '';
      prompt := 'Enter the password you want (up to 11 charactors): ';
      password := allcaps(getinput(prompt, 11,echo));
      str(usernum,temp);
      while length(temp) < 3 do temp := '0' + temp;
      password := temp + password;
      lineout(space);
      lineout('Your New Password is '+password);
      ch := getcap('Did Ya SCREW up ? ');
    until (ch = 'N') or not cts;
    lineout('New password is saved when you [D]ematerialize.');
  end;

procedure listusers;
{lists the current users }
  var
    I      : byte;
    inch   : char;
    inl,
    inp,
    temp   : line;
    infile : text;
  begin
    if cts then begin
      clearsc;
      assign(infile,'USER.TXT');
      reset(infile);
      lineout(':] Passengers on the Ship :]');
      repeat
        inch := getcap('[M]atch or [A]ll ? ');
      until ((inch in ['M','A']) or ( not cts ));
      if ((inch = 'M') and cts)
        then begin
          repeat
            stringout('Enter matching letters.'+ cr + lf + '-> ');
            temp := inputstring(echo,30);
          until ((length(temp) > 0) or ( not cts ));
          inp := temp;
          for i := 1 to length(temp) do inp[i] := upcase(temp[i]);
           while cts and not(eof(infile) or cancelled) do
             begin
               canstat := true;
               readln(infile,inl);
               if pos(inp,inl) > 0 then lineout(inl);
             end;
        end
        else begin
          lineout('Deckhands Aboard.');
          while cts and not(eof(infile) or cancelled) do
          begin
            canstat := true;
            readln(infile,inl);
            lineout(inl);
          end;
        end;
    end;
    canstat := false;
    close(infile);
  end;

procedure userlog;
{reads and outputs the contents of timelog.bbs }
  var
    temp :   person;
  begin
    if cts then begin
      canstat := true;
      assign(logfile, 'TIMELOG.BBS');
      clearsc;
      {$I-} reset(logfile) {$I+};
      if IOresult <> 0 then rewrite(logfile);
      while cts and (not cancelled) and not eof(logfile) do begin
        read(logfile,logrec);
        temp := logrec.who;
        while length(temp) < 25 do temp := temp + space;
        stringout(temp);
        temp := logrec.rate;
        while length(temp) < 4 do temp := space + temp;
        stringout(temp + ' Baud ');
        temp := logrec.msgs;
        while length(temp) < 2 do temp := space + temp;
        stringout(temp + ' Msgs ');
        lineout(logrec.when + '-' + logrec.done);
      end;
      if access = sysop then begin
        if getcap('Kill (Y/N)? ') = 'Y' then rewrite(logfile);
      end;
      close(logfile);
      canstat := false;
    end;
  end;

procedure getdefaults;
{ gets the defaults for the user and assigns them to global variables}
  begin
    if cts then begin
      with idrec do begin
        caller := user;
        real_name := user2;
        address := addr;
        town_city := city;
        state_zip := szip;
        phone_number := phnn;
        downloads := dld;
        uploads := uld;
        messages_posted := mptd;
        logged_on := lgdn;
        password := pass;
        expert := (exfl = 0);
        access := acc;
        last_time_on := lsto;
        cs := clr;
        bs := bsp;
        lf := lnf;
        caps := upc;
        width := wid;
        today_date := tdt;
        today_month := tmo;
        today_year := tyr;
        today_timeon := tto;
        special_access := speca;
        init_logon := intlg;
        for subboard := 1 to numsects do
          last_message[subboard] := lstm[subboard];
        subboard := 1;
        lineout('Last on: ' + lsto);
      end;
    end;
  end;

procedure introduce;
  begin
    lineout(cr + lf + 'Getting new user password & terminal info:');
    if cts then begin
      newpass;
      setvideo;
      if caller = SYSOP_NAME
        then begin
          access := sysop;
          special_access := 255;
        end else access := newuser;
    end;
  end;

procedure logcall;
{ update timelog.bbs when the user signs off}
const
  maxlog = 50;
var i,j : integer;
    logar : array[1..maxlog] of log;
  begin
    i := 0;
    assign(logfile, 'TIMELOG.BBS');
    {$I-} reset(logfile) {$I+};
    if IOresult <> 0 then rewrite(logfile);
    if filesize(logfile) > 0 then
      for i := 1 to filesize(logfile) do
        read(logfile,logar[i]);
    if i = maxlog
      then begin
        for j := 2 to i do
          logar[j-1] := logar[j];
        i := i - 1;
      end;
    i := i + 1;
        logar[i].who := caller;
        logar[i].when := timeon;
        logar[i].done := timeoff;
        logar[i].rate := itoa(baud);
        logar[i].msgs := itoa(msg_nailed);
    if logar[i].who = space then i := i - 1;
    reset(logfile);
    for j := 1 to i do write(logfile,logar[j]);
    close(logfile);
  end;

procedure endcall;
  begin
      clock(year, offmonth, offdate, offhour, offmin);
      timeoff := time(year, offmonth, offdate, offhour, offmin);
    if good_signon then logcall;
  end;

overlay procedure other_bbs;
{user maintained bbs list, (now i dont have to do it!)}
type
  bbsrecord = record
      bbsname      :  longname;
      bbsnumber    :  name;
      bbsloc       :  longname;
      bbscomments  :  line;
      poster       :  person;
  end;
var
  temprec,bbsrec : bbsrecord;
  bbsfile : file of bbsrecord;
  ch,ch1 : char;
  temps : line;
  I,j : integer;
  found : boolean;

begin
  assign(bbsfile,otherbbs);
  {$I-} reset(bbsfile); {$I+}
  if ioresult <> 0 then rewrite(bbsfile);
  clearsc;
  Lineout(':] Other Sailing Ships :]');
  if cts then ch := getcap('[L]ist, [A]dd, [D]elete ? ');
  if ((ch = 'L') and cts)
    then begin
      canstat := true;
      reset(bbsfile);
      i := 0;
      j := filesize(bbsfile);
      while((i < j) and cts and (not cancelled)) do
        begin
          read(bbsfile,bbsrec);
          i := i + 1;
          if bbsrec.bbsname <> 'EMPTY'
            then begin
               temps := bbsrec.bbsname;
               while (length(temps) < 25 ) do temps := temps + ' ';
               temps := '*' + temps + bbsrec.bbsnumber +' '+ bbsrec.bbsloc;
               lineout(temps);
               if length(bbsrec.bbscomments) > 1 then lineout(bbsrec.bbscomments);
             end;
        end;
      canstat := false;
    end else if((ch = 'A') and cts)
      then begin
        bbsrec.bbsname := allcaps(getinput('BBS Name ? ',25,echo));
        if ((length(bbsrec.bbsname) > 1) and cts)
          then begin
            bbsrec.bbsnumber := getinput('Phone Number ? ###-###-####'
                                          + back(12),14,echo);
            bbsrec.bbsloc := getinput('City & State ? ',25,echo);
            bbsrec.bbscomments := getinput('Additional Comments (70 chars) ? ',70,echo);
            bbsrec.poster := caller;
            repeat
              ch1 := getcap('S]ave or A]bort ? ');
            until ((ch1 in ['A','S']) or (not cts));
            if ch1 = 'S' then
              begin
                I := 0;  found := false; j := filesize(bbsfile);
                while ((not found) and cts and ( i < j )) do
                begin
                  reset(bbsfile);
                  seek(bbsfile,i);
                  read(bbsfile,temprec);
                  if (temprec.bbsname = 'EMPTY') then found := true
                                                 else i := i + 1;
                end;
                if found then seek(bbsfile,i)
                         else seek(bbsfile,j);
                write(bbsfile,bbsrec);
              end;
          end;
    end else if ((ch = 'D') and cts)
      then begin
        if access < 3 then stringout('Need Access level 3 to Delete ! ' + cr + lf)
        else begin
          temps := allcaps(getinput('Name of BBS to delete from list ? ',25,echo));
          Stringout('OK Searching... ');
          reset(bbsfile);
          I := 0;  found := false; j := filesize(bbsfile);
          while ((not found) and cts and ( i < j )) do
            begin
              seek (bbsfile,I);
              read (bbsfile,bbsrec);
              if temps = bbsrec.bbsname then found := true
                                        else I := I + 1;
            end;
          If not found then stringout('I can''t find IT! ')
            else begin
              stringout('Updating File... ');
              seek (bbsfile,i);
              bbsrec.bbsname := 'EMPTY';
              write(bbsfile,bbsrec);
            end;
        end;
    end;
    close(bbsfile);
end;

overlay procedure apply;
{gathers newuser information}
var ch: char;
    found : boolean;
    loc : integer;
  begin
  if cts then begin
    repeat
        clearsc;
        outfile(applying);
        repeat
          caller := allcaps(getinput('Whats Yer Name ? ',22,echo));
          lineout(space);
          lineout('Searching for duplicate name....');
          find_name(caller,loc,found);
          if found then lineout('That NAME is in USE!');
          lineout(space);
        until (((not found) and (length(caller) > 3)) or (not cts));
        if cts then
        repeat
          real_name := allcaps(getinput('Whats Yer Real name ? ',25,echo))
        until ((length(real_name) > 5) or (not cts));
        if cts then
        repeat
          Address := allcaps(getinput('Street address ? ',25,echo));
        until ((length(address) > 5) or (not cts));
        if cts then
        repeat
          town_city := allcaps(getinput('City ? ',25,echo));
        until ((length(town_city) > 5) or (not cts));
        if cts then
        repeat
          state_zip := allcaps(getinput('State & Zip ? ',25,echo));
        until ((length(state_zip) > 5) or (not cts));
        if cts then
        repeat
          phone_number := allcaps(getinput('Phone Number ? (###-###-####) ',12,echo));
          if (length(phone_number) <> 12) then lineout('Incorrect Format!');
        until ((length(phone_number) = 12) or (not cts));
        lineout(space);
        lineout('You said:');
        lineout(real_name);
        lineout(address);
        lineout(town_city);
        lineout(state_zip);
        lineout(phone_number);
        charout(cr);charout(lf);
        ch := getcap('Did Ya SCREW up ? ');
    until (ch = 'N') or (not cts);
    lineout(space);
    inbuffer := '';
    if not cts then good_signon := false;
  end;
end;

overlay procedure userstats;
begin
  lineout('Name :         ' + caller);
  lineout('Password :     ' + password);
  lineout('Phone Number : ' + phone_number);
  lineout('Last Voyage :  ' + last_time_on);
  lineout('Voyages made : ' + itoa(logged_on));
  lineout('Msgs Nailed :  ' + itoa(messages_posted));
  lineout('Cargo Unloaded:' + itoa(downloads));
  lineout('Cargo Uploaded:' + itoa(uploads));
  lineout('Access Level : ' + itoa(access));
  showtime;
  stringout('This Call ');
  connecttime;
  if access < 4 then
    lineout('You have ' +  itoa(maxminon - (usehour * 60) - today_timeon - usemin) + ' Minutes left');
end;

procedure signon(var caller: person);
{ sign on procedure }
  var ch: char;
      tries: byte;
      temp : name;
      ok,new : boolean;
  begin
    ch := space;
    tries := 0;
    new := false;
    lineout('What be your Password Traveler,');
    lineout('Or are you NEW ? ');
    repeat
      tries := tries + 1;
      repeat
        password := allcaps(getinput(')->'#8#8#8')=->'#8#8#8#8')==-> ', 28, echo));
      until (length(password) >= 3) or not cts;
      if (cts and (password <> 'NEW'))
        then begin
          lineout('Searching userlist...');
          ok := findid(password);
          if not ok then lineout(cr+'Password not found')
            else lineout('Found it!');
        end;
      if ((not ok) and (tries >= 3) and (password <> 'NEW')) then hangup;
    until (ok or (not cts) or (password = 'NEW'));
    if (ok and (password <> 'NEW') and cts ) then
    begin
      tries := 0;
      lineout(space);
      lineout('I have yet ANOTHER test,');
      lineout('Do you remember your phone number:');
      repeat
        if tries >= 3 then hangup
          else begin
             temp := getinput(')->'+ copy(idrec.phnn,1,8) + '####'
                                   + #8#8#8#8 , 12, echo);
             tries := tries + 1;
             phone_number := copy(idrec.phnn,1,8) + temp;
             if ((phone_number <> idrec.phnn) and (tries < 3))
               then lineout('Dummy! Try Again!');
          end;
      until (phone_number = idrec.phnn) or (not cts);
    end;
    if cts then begin
      if password = 'NEW' then
        begin
          new := true;
          apply;
          introduce;
         end
         else getdefaults;
      if ((usernum > 1) and (access = 5)) then access := 1;
      update_userlog('******************************************************');
      if new then update_userlog('*** NEW USER ***');
      update_userlog('Start time: ' + timeon + cr + lf +
                      caller + ' (' + real_name + ')' + cr + lf +
                      'Password: ' + password + '  Phone Number: ' + phone_number);
      if access = twit then begin
        lineout('Voyager ' + caller + ' has been denied system access.');
        hangup;
      end else if cts then good_signon := true;
      if good_signon then
        begin
          if not local then callnum := callnum + 1;
          update_userlog('Caller Number: ' + itoa(callnum));
          dispcaller;
          lineout(space);
          lineout('Welcome Aboard ' + caller);
          lineout(space);
          clock(year,month, date, hour, min);
          if date <> today_date
            then begin
              today_timeon := 0;
              today_date := date;
            end;
        end;
      end;
  end;
