PROGRAM Contour_Test;
{test of contour plot routines}
{ comment out the following line if you do not wish to use the units from
  the Turbo Professional package from TurboPower Software }
{$DEFINE UseTurboProfessional}

{$IFDEF UseTurboProfessional}
USES TPCrt,Graph,Higraf;
{$ELSE}
USES Crt,Graph,Higraf;
{$ENDIF}
CONST
  {setup for this particular piece of data}
  X_Size = 50;
  Y_Size = 50;
  Num_Contours = 30;

PROCEDURE Init_Array ;
VAR
    i : INTEGER;
BEGIN
  NEW(TwoD_Array_Pointer);
  FOR  i:=0  TO Max_X_Size-1 DO
    NEW(TwoD_Array_Pointer^[i]);
END;

VAR
  i,j : LONGINT;
  max, min: LONGINT;
  key : CHAR;
BEGIN
  {allocate memory to data and contour arrays, this must always be the
   first thing you do when using this package}
  Init_Array;

  {fill data array with sum of two Gaussians plus noise for this demo}
  min:=1000000;
  max:=-1000000;
  FOR  i:= 0 TO X_Size-1 DO
  BEGIN
    FOR  j:= 0 TO Y_Size-1 DO
    BEGIN
      TwoD_Array_Pointer^[i]^[j]:=ROUND(
        30000.0*EXP(-1*(SQR(i-35)+3.0*SQR(j-40))/450.0)+
        30000.0*EXP(-1*(3.0*SQR(i-10)+SQR(j-15))/450.0)+
        RANDOM(1500));
      IF (min > TwoD_Array_Pointer^[i]^[j]) THEN
        min:=TwoD_Array_Pointer^[i]^[j];
      IF (max < TwoD_Array_Pointer^[i]^[j]) THEN
        max:=TwoD_Array_Pointer^[i]^[j];
    END;
  END;
  {now make the contour levels}
  FOR i:= 0 TO Num_Contours-1 DO
    Contours[i]:=min+i*(max-min)/(Num_Contours-1);
  WRITELN('Filled data arrays, hit any key to continue.');
  WRITE('After plotting finished, hit any key to return to DOS');
  key:=ReadKey;
  {go to graphics mode}
  Initialize_Graph;
  Setup_Graph(0.0,X_Size+2,0.0,Y_Size+2,15,85,15,85,lin,lin);

  { do color plot }
  Frame(X_Size/50,Y_Size/50,5,5,FALSE);
  Label_Axes(X_Size/10,Y_Size/10);
  XaxisTitle('X Axis');
  YaxisTitle('Y Axis');
  {plot the data}
  Contour_Plot(0,X_Size-1,1,0,Y_Size-1,1,Num_Contours,TRUE);
  Write_StatusLine('Color plot of contours; press any key to continue.');
  key:=ReadKey;

  { now do "monochrome" contour plot using line styles }
  ClearDevice;
  Frame(X_Size/50,Y_Size/50,5,5,FALSE);
  Label_Axes(X_Size/10,Y_Size/10);
  XaxisTitle('X Axis');
  YaxisTitle('Y Axis');
  {plot the data}
  Contour_Plot(0,X_Size-1,1,0,Y_Size-1,1,Num_Contours,FALSE);
  Write_StatusLine('Line style plot of contours; press any key to continue.');
  key:=ReadKey;

  { now do contour plot using colors only }
  ClearDevice;
  Frame(X_Size/50,Y_Size/50,5,5,FALSE);
  Label_Axes(X_Size/10,Y_Size/10);
  XaxisTitle('X Axis');
  YaxisTitle('Y Axis');
  {plot the data}
  Color_Contour_Plot(0,X_Size-1,1,0,Y_Size-1,1,Num_Contours);
  Write_StatusLine('Contour plot using colors only; press any key to continue.');
  key:=ReadKey;

  {return to text screen}
  CloseGraph;
END.
