PROGRAM Higraf_Test;

{ comment out the following line if you do not wish to use the units from
  the Turbo Professional package from TurboPower Software }
{$DEFINE UseTurboProfessional}

{$IFDEF UseTurboProfessional}
USES TPCrt,Graph,Higraf;
{$ELSE}
USES Crt,Graph,Higraf;
{$ENDIF}

TYPE FLOAT = EXTENDED;

VAR
  x,y: FLOAT;

function sinc(x: FLOAT): FLOAT;

BEGIN
  IF x=0.0 THEN sinc:=1.0 ELSE sinc:=sin(x)/x;
END;

function sincsq(x: FLOAT): FLOAT;

BEGIN
  sincsq:=sinc(x)*sinc(x);
END;

BEGIN
  Initialize_Graph;
  Setup_Graph(-20.0,20.0,-0.5,1.2,10.0,45.0,10.0,85.0,lin,lin);
  Frame(1.0,0.1,5,5,TRUE);
  Axes(0.0,0.0,1.0,0.1,5,5,FALSE);
  Label_Axes(5.0,0.5);
  Toptitle('Sinc Function');
  Xaxistitle('x (radians)');
  Yaxistitle('sinc(x)');
  x:=-20.0;
  SetColor(Red);
  SetFillStyle(SolidFill,Red);
  REPEAT
    PlotPoint(x,sinc(x),7,2);
    x:=x+0.5;
  UNTIL x > 20.0;
  SetColor(Green);
  SetFillStyle(SolidFill,Green);
  PlotData(6.7,2.0,0.77,0.15,7,4);

  SetColor(GetMaxColor);
  Setup_Graph(0.1,20.0,1.0e-5,1.0,55.0,95.0,10.0,85.0,log,log);
  Frame(1.0,0.1,5,5,TRUE);
  Axes(0.1,1.0e-5,1.0,0.1,5,5,FALSE);
  Label_Axes(5.0,0.5);
  Toptitle('Sincsq Function');
  Xaxistitle('x (radians)');
  Yaxistitle('sincsq(x)');
  SetColor(Yellow);
  x:=0.1;
  Move(x,sincsq(x));
  REPEAT
    Draw(x,sincsq(x));
    x:=x+0.05;
  UNTIL x > 20.0;

  { just for grins, add gothic label demo }
  SetColor(Cyan);
  Draw_Label(0.1,0.015,'Draw_Label Demo', GothicFont,HorizDir,2,
                     LeftText,CenterText);

  READLN;
  CloseGraph;
END.