Program IOtester;

Uses Crt, {only for the Keypressed function}
     IO;  {  <=== This is it }

(*   This demo will demonstrate the pros and cons of the video addressing
     types. The only thing non-standard about it, is that this program
     uses KeyPressed to detect the "press any key .." which bypasses the
     Standard IO, and uses a BIOS keyboard routine.                       *)

(* IO and IODEMO are written by P.Mackay. *)
(* Copyright (C) 1988 All Rights Reserved *)

procedure Routine;

var
  i : integer;
  ch: char;


begin
  IOClrScr;
  IOTextcolor(7);
  writeln ('TEST;  I/O testing program');
  IOgotoxy(6,4);
  IOtextcolor(2);
  writeln ('This program will demostrate the capabilities of the IO unit.');
  if IOmethod = ANSI then
    begin
      IOgotoxy(14,8);
      IOtextcolor(14);
      writeln ('Current operation: ANSI (standard-output)');
      IOgotoxy(1,10);
      IOtextcolor(3);
      writeln ('   ANSI output uses a special sequence of control codes to send information');
      writeln ('on things such as colour, cursor position etc .. A ANSI driver, however');
      writeln ('is required to see these. ANSI is slow, but very useful for re-direction');
      writeln ('in that it can be sent to a remote over a modem connection.');
    end;
  If IOmethod = BIOS then
    begin
      IOgotoxy(14,8);
      IOtextcolor(14);
      writeln ('Current operation: BIOS');
      IOgotoxy(1,10);
      IOtextcolor(3);
      writeln ('   BIOS output is many times slower than DIRECT, but it is useful in multi-');
      writeln ('tasking environments, where a program can re-route the BIOS video calls.');
      writeln ('Programs which have bulk output would not use BIOS, but BIOS is good for');
      writeln ('static output.');
    end;
  if IOmethod = DIRECT then
    begin
      IOgotoxy(14,8);
      IOtextcolor(14);
      writeln ('Current operation: DIRECT');
      IOgotoxy(1,10);
      IOtextcolor(3);
      writeln ('   DIRECT output is where a program directly writes to the memory on the');
      writeln ('display adapter. The only problems with this, is it sometimes causes snow');
      writeln ('and may not work on some flavours of MS-DOS. Direct-writes are used by');
      writeln ('most applications today, as it is so incredibly fast.');
      writeln ('   It is so fast, infact, you may not be able to see the line below becuase');
      writeln ('it is being updated so frequently. (depends on computer type)');
    end;

  IOgotoxy(15,16);
  IOtextcolor(15);
  write ('Speed test: (press any key)');

  i := 0;
  repeat
    IOgotoxy(5,20);
    write ('This is being written, wiped and re-written: ',i);
    IOgotoxy(5,20);
    write ('                                             ');
    i := i + 1;
  until keypressed;

  ch := readkey;
end;

begin
  CheckSnow := False;

  OutputMethod(ANSI);
  Write (BlackB);     (* Black background ANSI code *)
  Routine;

  OutputMethod(BIOS);
  Routine;

  OutputMethod(DIRECT);
  Routine;

  OutputMethod(ANSI);
  IOClrscr;
  IOTextcolor(15);
  IOTextbackground(1);
  Write ('IO; ANSI/BIOS/DIRECT routines for Turbo-Pascal v4 & 5 DEMO by P.Mackay');
  IOClrEol;
  IOTextbackground(0);
  IOTextcolor(7);
  writeln;
  writeln;
end.
