{ TPBoard 4.2 Copyright (c) 1987,88 by Jon Schneider & Rick Petersen  
  Portions Copyright (c) 1986,87 by Steve Fox and Les Archambault  
  
  Last modified  ::  9-9-88 7:56 pm 
}

{$R-}                             {Range checking off}
{$B-}                             {Boolean complete evaluation off}
{$S-}                             {Stack checking off}
{$I+}                             {I/O checking on}
{$N-}                             {No numeric coprocessor}

Unit NetRead;

Interface

Uses
  TPCrt, Dos, Globals, Core1, Core2, NetEntr,
  NetMisc, TPASCIIZ, TPSTRING, TPDOS;
  
  
procedure fido_mesg_read(mode : Char);


  {==========================================================================}
  
  
Implementation



  procedure fido_mesg_read(mode : Char);
    { Read message }
    
    
  type
  
    last_read =
      record
        message         : Integer;
      end;
      
    byte_array      = array[1..2048] of Byte;
    BuffPtr         = ^byte_array;
    
  var
    buffer          : BuffPtr;
    lread           : last_read;
    last_file       : file of last_read;
    byte_file       : untype_file;
    ch, option      : Char;
    found, quit,
    public, skip,
    from_equal,
    reply,
    to_equal,
    replyed,
    previous,
    non_stop, OK,
    sent, endfile,
    header_ok       : Boolean;
    i,
    high_msg_num,
    number_msgs,
    curr_msg,
    count           : Integer;
    index,
    remaining       : Word;
    to_str,
    from_str,
    from_other,
    to_other        : Str36;
    date_str        : Str20;
    subj_str,
    pr_str          : Str72;
    msg_num_str     : string[4];
    byt             : Byte;
    This            : AreaPtr;
    
    
    procedure read_block;
    
    begin
      if EOF(byte_file) then
        endfile := True
      else
        BlockRead(byte_file, buffer^, 2048, remaining);
      index := 1;
    end;
    
    
    function get_byte : Byte;
    
    begin
      if endfile then
        get_byte := 0
      else
        begin
          get_byte := buffer^[index];
          if index = remaining then
            read_block
          else
            Inc(index);
        end;
    end;
    
    
    procedure get_msg_hdr(curr_msg        : Integer;
                          var from_equal  : Boolean;
                          var to_equal    : Boolean);
                          
    begin
      header_ok := False;
      FillChar(temp_asciiz, 73, 0);
      Str(curr_msg, msg_num_str);
      Assign(fido_file, msg_num_str+'.MSG');
      {$I-}
      Reset(fido_file) {$I+} ;
      OK := (IoResult = 0);
      if OK then
        begin
          {$I-}
          Read(fido_file, msg_hdr) {$I+} ;
          if IoResult = 0 then
            begin
              with msg_hdr do
                begin
                  Move(date, temp_asciiz, 19);
                  date_str := Asc2Str(temp_asciiz);
                  Move(msg_to, temp_asciiz, 35);
                  to_str := Asc2Str(temp_asciiz);
                  Move(msg_from, temp_asciiz, 35);
                  from_str := Asc2Str(temp_asciiz);
                  Move(subject, temp_asciiz, 71);
                  subj_str := Asc2Str(temp_asciiz);
                  from_equal := (CompUCString(from_str, from_other) = Equal);
                  if (user_rec.fn = 'SYSOP') and (not from_equal) then
                    from_equal := (CompUCString(from_str, user_rec.fn) = Equal);
                  to_equal := (CompUCString(to_str, to_other) = Equal);
                  if (user_rec.fn = 'SYSOP') and (not to_equal) then
                    to_equal := (CompUCString(to_str, user_rec.fn) = Equal);
                  public := not(test_bit(attr_low, 0));
                  sent := test_bit(attr_low, 3);
                  header_ok := True;
                end;
            end;
          Close(fido_file)
        end
      else
        header_ok := False;
      if (not header_ok) then
        begin
          Erase(fido_file);
          fido_sort(high_msg_num, number_msgs, msg_numbers);
          SetSect(FidoArea);
          Dec(i);   
          curr_msg := msg_numbers[i];
        end;
    end;
    
    
    procedure display_hdr(curr_msg : Integer);
    
    begin
      WriteLn(Com, yellow);
      WriteLn(Com);
      if sent then
        Write(Com, 'Sent ')
      else
        if public then
          Write(Com, 'Public ')
        else
          Write(Com, 'Private ');
      Write(Com, 'message # ', msg_num_str, '   ');
      if AreaReq[1] <> '-' then
        Write(Com, AreaReq, ' AREA ')
      else
        begin
          st := Copy(AreaReq, 2, 12);
          Write(Com, st, ' ECHO ');
        end;
      WriteLn(Com, '  Entered: ', date_str);
      Write(Com, white, 'From: ', cyan, from_str);
      if AreaReq[1] <> '-' then
        WriteLn(Com, ' on ', msg_hdr.orig_net, '/', msg_hdr.orig_node)
      else
        WriteLn(Com);
      Write(Com, white, '  To: ', cyan, to_str);
      if AreaReq[1] <> '-' then
        WriteLn(Com, ' on ', msg_hdr.dest_net, '/', msg_hdr.dest_node)
      else
        WriteLn(Com);
      if (Pos('Re:', subj_str) <> 0) then
        Delete(subj_str, 1, 4);
      WriteLn(Com, white, '  Re: ', cyan, subj_str);
      if (TempLastRead[msg_offset] < curr_msg) and (not(mode in ['S', 'Q'])) then
        TempLastRead[msg_offset] := curr_msg;
    end;
    
    
    procedure ask_delete;
    
    var
      pr_str          : StrPr;
      OK,
      deleted_last,
      found           : Boolean;
      next_to_last    : Integer;
      num_str         : string[4];
      
      
    begin
      deleted_last := False;
      if (not skip) and (not quit) and (not previous) and (not replyed) then
        begin
          WriteLn(Com);
          if reply then
            pr_str := 'DELETE original message'
          else
            begin
              pr_str := 'DELETE this message';
              if (curr_msg = high_msg_num) and (number_msgs > 1) then
                deleted_last := True;
            end;
          reply := False;
          if ask(white+pr_str+cyan, 'N') then
            begin
              if ask(white+'Are you sure'+cyan, 'N') then
                begin
                  WriteLn(Com);
                  {$I-}
                  Close(byte_file);
                  Erase(byte_file);
                  if deleted_last then
                    begin
                      next_to_last := msg_numbers[Pred(number_msgs)];
                      Str(next_to_last, num_str);
                      Assign(temp_file, num_str+'.MSG');
                      Str(high_msg_num, num_str);
                      Rename(temp_file, num_str+'.MSG')
                    end;
                  {$I+}
                  OK := (IoResult = 0);
                  if ExistFile(nsum_name+ext) then
                    begin
                      Assign(fido_summ_file, nsum_name+ext);
                      Reset(fido_summ_file);
                      OK := FileSize(fido_summ_file) > 0;
                      if OK then
                        begin
                          Seek(fido_summ_file, Pred(FileSize(fido_summ_file)));
                          Read(fido_summ_file, summary_record);
                        end;
                      if OK and (summary_record.number >= msg_numbers[i]) then
                        begin
                          found := False;
                          Seek(fido_summ_file, 0);
                          while (not EOF(fido_summ_file)) and (not found) do
                            begin
                              Read(fido_summ_file, summary_record);
                              found := (summary_record.number = msg_numbers[i]);
                            end;
                          if found then
                            begin
                              summary_record.to_loc := 0;
                              summary_record.from_loc := 0;
                              Seek(fido_summ_file, Pred(FilePos(fido_summ_file)));
                              Write(fido_summ_file, summary_record);
                            end;
                          if deleted_last then
                            begin
                              found := False;
                              Seek(fido_summ_file, 0);
                              while (not EOF(fido_summ_file)) and (not found) do
                                begin
                                  Read(fido_summ_file, summary_record);
                                  found := (summary_record.number = next_to_last);
                                end;
                              if found then
                                begin
                                  Seek(fido_summ_file, Pred(FilePos(fido_summ_file)));
                                  summary_record.number := high_msg_num;
                                  Write(fido_summ_file, summary_record);
                                end;
                            end;
                        end;
                      Close(fido_summ_file);
                    end
                  else
                    WriteLn(Com, 'Can''t find NetMail Summary File');
                  SetSect(HomName);
                  fido_sort(high_msg_num, number_msgs, msg_numbers);
                  SetSect(FidoArea);
                  Dec(i);
                  WriteLn(Com, 'Message deleted')
                end
              else WriteLn(Com, 'Message retained');
            end;
        end;
    end;
    
    
    procedure find_next_msg_num;
    
    begin
      if (not replyed) and (not previous) then
        begin
          Inc(i);
          curr_msg := msg_numbers[i];
          if curr_msg = 0 then quit := True
        end;
      if previous then
        begin
          if i > 1 then i := Pred(i);
          curr_msg := msg_numbers[i];
          if curr_msg = 0 then quit := True;
          previous := False
        end;
      replyed := False;
    end;
    
    
    procedure display_text(var curr_msg : Integer; var quit : Boolean);
    
    var
      i, line_count   : Integer;
      whole_word      : StrStd;
      done,
      OriginLine,
      SeenBy          : Boolean;
      
      
      procedure cr_lf;
      
      begin
        WriteLn(Com);
        Inc(line_count);
        if (user_rec.lines <> 99) and (not non_stop) then
          if line_count = user_rec.lines then
            begin
              pause;
              line_count := 0
            end;
      end;
      
      
    begin
      quit := False;
      abort := False;
      if (not non_stop) then
        begin
          repeat
            WriteLn(Com, white);
            if user_rec.access < 250 then
              pr_str := intstr(time_left, 1)+'-'+yellow+'Read <Y><N><R><P><C><Q>'
            else
              pr_str := intstr(time_left, 1)+'-'+yellow+'Read <Y><N><R><P><C><D><Q>';
            st := prompt(pr_str+cyan, 1, 'ESA?M');
            WriteLn(Com);
            if Ord(st[0]) = 1 then
              ch := st[1]
            else
              ch := '?';
            if ch = '?' then
              begin
                if user_rec.access < 250 then
                  pr_str := '<Y>es, <N>o, <R>eply, <P>revious, <C>ontinous, <Q>uit'
                else
                  pr_str :=
                  '<Y>es, <N>o, <R>eply, <P>revious, <C>ontinous, <D>elete, <Q>uit';
                WriteLn(Com, pr_str);
                mult_cmds := False;
                Cmd_Queue := '';
              end;
          until (not Online) or (ch in ['Y', 'N', 'R', 'P', 'C', 'Q']) or
          ((user_rec.access >= 250) and (ch = 'D'));
          case ch of
            'Q' :
              begin
                quit := True;
                if (TempLastRead[msg_offset] = curr_msg) and (not(mode in
                  ['S', 'Q'])) then
                  TempLastRead[msg_offset] := Pred(curr_msg);
              end;
            'N' :
              skip := True;
            'Y' :
              skip := False;
            'P' :
              begin
                if option = 'F' then
                  begin
                    found := False;
                    previous := True;
                    find_next_msg_num;
                    while (not found) and (msg_numbers[1] <> curr_msg) do
                      begin
                        previous := True;
                        find_next_msg_num;
                        get_msg_hdr(curr_msg, from_equal, to_equal);
                        found := from_equal;
                      end;
                  end;
                if option = 'T' then
                  begin
                    found := False;
                    previous := True;
                    find_next_msg_num;
                    while (not found) and (msg_numbers[1] <> curr_msg) do
                      begin
                        previous := True;
                        find_next_msg_num;
                        get_msg_hdr(curr_msg, from_equal, to_equal);
                        found := to_equal;
                      end;
                  end;
                previous := True;
              end;
            'C' :
              begin
                non_stop := True;
                skip := False
              end;
            'D' :
              begin
                skip := False;
                Assign(byte_file, msg_num_str+'.MSG');
                {$I-}
                Reset(byte_file) {$I+} ;
                OK := (IoResult = 0);
                if OK then
                  ask_delete;
                skip := True
              end;
            'R' :
              begin
                SetSect(HomName);
                fido_mesg_enter('R', from_str, subj_str, msg_num_str, high_msg_num);
                SetSect(FidoArea);
                replyed := True
              end;
          end;
        end;
        
      if ((not skip) and (not quit) and (not replyed) and (not previous)) then
        begin
          check_time;
          Assign(byte_file, msg_num_str+'.MSG');
          {$I-}
          Reset(byte_file, 1);
          Seek(byte_file, 190) {$I+} ;
          OK := (IoResult = 0);
          endfile := (not OK);
          if OK then
            begin
              OriginLine := False;
              line_count := 1;
              read_block;
              done := False;
              repeat
                byt := get_byte;
                case Chr(byt) of
                  NUL :
                    done := True;
                  SOH :
                    repeat
                      byt := get_byte;
                      done := (byt = 0)
                    until (Chr(byt) = CR) or done;
                  SPC :
                    Write(Com, Chr(byt));
                  CR :
                    cr_lf;
                  LF, SoftCR :
                    if non_stop then non_stop := (not brk);
                  TAB :
                    for i := 1 to (8-(WhereX mod 8)) do
                      Write(Com, ' ');
                else
                  begin
                    whole_word := Chr(byt);
                    repeat
                      byt := get_byte;     
                      if (Chr(byt) <> NUL) then
                        begin
                          if (Chr(byt) <> CR) and (Chr(byt) <> SoftCR) then
                            whole_word := whole_word+Chr(byt)
                        end
                      else done := True
                    until (byt = Ord(SPC)) or (byt = Ord(CR)) or done;
                    SeenBy := (Pos('SEEN-BY:', whole_word) = 1);
                    if (not OriginLine) then
                      OriginLine := (whole_word = 'Origin:');
                    if (WhereX <> 1) or ((not OriginLine) and (not SeenBy)) then
                      begin
                        if WhereX+Ord(whole_word[0]) > Pred(user_rec.columns) then
                          cr_lf;
                        if (whole_word = 'Origin: ') and (WhereX = 4) then
                          Write(Com, white, BS, BS, '*', SPC);
                        Write(Com, whole_word);
                        if byt = Ord(CR) then
                          cr_lf;
                      end
                    else
                      repeat
                        byt := get_byte;     
                        done := (byt = 0);
                      until (byt = Ord(CR)) or (byt = Ord(LF)) or done;
                  end;
                end;
              until done or (not Online);
              Close(byte_file)
            end;
          if to_equal and (not non_stop) then
            begin
              WriteLn(Com);
              if ask(white+'Reply to this message'+cyan, 'N') then
                begin
                  SetSect(HomName);
                  fido_mesg_enter('R', from_str, subj_str, msg_num_str, high_msg_num);
                  SetSect(FidoArea);
                  Assign(byte_file, msg_num_str+'.MSG');
                  reply := True
                end;
            end;
          if (line_count+7 >= user_rec.lines) and (not to_equal)
          and (not non_stop) then pause
        end;
    end;
    
    
    procedure display_msg;
    
    begin
      found := True;
      if header_ok then
        begin
          display_hdr(curr_msg);
          if non_stop then WriteLn(Com);
          display_text(curr_msg, quit);
        end;
    end;
    
    
    procedure Get_Start;
    
    var
      last, low,
      high            : Integer;
      
    begin
      if ((option = 'N') or (mode in ['S', 'Q'])) then
        repeat
          WriteLn(Com);
          last := user_rec.last_read[msg_offset];
          high := high_msg_num;
          low := msg_numbers[1];
          curr_msg := strint(prompt('Start'+' (last mesg you read is '+intstr(last, 1)+') '+
            ' ['+intstr(low,
              1)+'-'+intstr(high, 1)+']?', 5, 'E'));
          if ((curr_msg < low) or (curr_msg > high)) and (curr_msg <> 0) then
            WriteLn(Com, 'Invalid message number, try again.');
        until ((curr_msg >= low) and (curr_msg <= high)) or (not Online) or (curr_msg = 0)
      else if (option = 'S') then
        curr_msg := Succ(user_rec.last_read[msg_offset])
      else
        curr_msg := 1;
      if curr_msg = 0 then
        i := 1024
      else
        while ((curr_msg > msg_numbers[i]) and (msg_numbers[i] <> 0))
        do Inc(i)
    end;
    
    
  begin                           { Fido_Msg_Read }
    OK := True;
    found := False;
    replyed := False;
    reply := False;
    quit := False;
    previous := False;
    non_stop := False;
    to_other := UserFullName;
    from_other := UserFullName;
    fido_sort(high_msg_num, number_msgs, msg_numbers);
    if AreaReq = 'NETMAIL' then
      FidoArea := fidomail
    else
      FidoArea := fidomail+'\'+AreaReq;
    SetSect(FidoArea);
    GetMem(buffer, 2048);
    if user_loc = 1 then
      begin
        Assign(last_file, 'LASTREAD');
        {$I-}
        Reset(last_file) {$I+} ;
        if IoResult = 0 then
          begin
            This := AreaBase;
            while (This <> nil) and (This^.AreaName <> AreaReq) do
              This := This^.next;
            if This^.AreaConf < 8 then
              begin
                Read(last_file, lread);
                if user_rec.last_read[msg_offset] < lread.message then
                  begin
                    user_rec.last_read[msg_offset] := lread.message;
                    TempLastRead[msg_offset] := lread.message;
                  end
                else
                  lread.message := user_rec.last_read[msg_offset];
                Seek(last_file, 0);
                Write(last_file, lread);
              end;
          end
        else
          begin
            Rewrite(last_file);
            lread.message := user_rec.last_read[msg_offset];
            Write(last_file, lread);
            This := AreaBase;
            while (This <> nil) and (This^.AreaName <> AreaReq) do
              This := This^.next;
            if This <> nil then
              This^.AreaConf := This^.AreaConf or 8;
          end;
        Close(last_file);
      end;
    i := 1;
    if (mode = ' ') and (high_msg_num > 0) then
      begin
        repeat
          WriteLn(Com, yellow);
          st := prompt('Read Search Option <A><F><T><N><S><Q> '+cyan, 80, 'ES?M');
          if Ord(st[0]) = 1 then
            option := st[1]
          else
            option := '?';
          if option = '?' then
            begin
              WriteLn(Com,
                '<A>ll, <F>rom, <T>o, <N>umeric, <S>ince your last call, <Q>uit');
              mult_cmds := False;
              Cmd_Queue := '';
            end;
        until (not Online) or (option in ['A', 'F', 'T', 'N', 'S', 'Q']);
        case option of
          'N', 'S', 'A' :
            begin
              Get_Start;
              if msg_numbers[i] <> 0 then
                begin
                  curr_msg := msg_numbers[i];
                  while (not quit) do
                    begin
                      get_msg_hdr(curr_msg, from_equal, to_equal);
                      if public or from_equal or to_equal
                      or (user_rec.access >= 250) then display_msg;
                      if (from_equal or to_equal) and (not non_stop) then
                        ask_delete;
                      find_next_msg_num
                    end;
                  if (not found) then
                    WriteLn(Com,
                      'Sorry, messages were either private or not found.');
                end
              else
                WriteLn(Com, 'No messages found.');
            end;
          'F' :
            begin
              from_other := '';
              if user_rec.access >= 250 then
                from_other := prompt('From whom [CR for Yourself]', len_name, 'EL');
              if from_other = '' then
                from_other := UserFullName;
              curr_msg := msg_numbers[i];
              while (not quit) do
                begin
                  get_msg_hdr(curr_msg, from_equal, to_equal);
                  if from_equal then
                    begin
                      display_msg;
                      if (not non_stop) then ask_delete;
                    end;
                  find_next_msg_num
                end;
              if (not found) then
                WriteLn(Com, 'No messages found.');
            end;
          'T' :
            begin
              to_other := '';
              if user_rec.access >= 250 then
                to_other := prompt('To whom [CR for Yourself]', len_name, 'EL');
              if to_other = '' then
                to_other := UserFullName;
              curr_msg := msg_numbers[i];
              while (not quit) do
                begin
                  get_msg_hdr(curr_msg, from_equal, to_equal);
                  if to_equal then
                    begin
                      display_msg;
                      if (not non_stop) then ask_delete;
                    end;
                  find_next_msg_num
                end;
              if (not found) then
                WriteLn(Com, 'No messages found.');
            end;
          'Q' :
            OK := False;
        end;
      end
    else if (mode in ['S', 'Q']) and (high_msg_num > 0) then
      begin
        Get_Start;
        if msg_numbers[i] <> 0 then
          begin
            curr_msg := msg_numbers[i];
            count := 0;
            while (not brk) and (not quit) do
              begin
                get_msg_hdr(curr_msg, from_equal, to_equal);
                if (public or from_equal or to_equal
                  or (user_rec.access >= 250)) and header_ok then
                  begin
                    found := True;
                    if mode = 'S' then
                      begin
                        display_hdr(curr_msg);
                        if user_rec.lines <> 99 then
                          begin
                            Inc(count);
                            if count mod 4 = 0 then pause
                          end;
                      end
                    else
                      begin
                        Write(Com, msg_num_str:4);
                        if from_equal or to_equal then
                          Write(Com, '*')
                        else
                          Write(Com, ':');
                        WriteLn(Com, ' ', subj_str);
                        if user_rec.lines <> 99 then
                          begin
                            Inc(count);
                            if count mod user_rec.lines = 0 then pause
                          end;
                      end;
                  end;
                find_next_msg_num
              end;
            if (not found) then
              WriteLn(Com, 'No messages found.');
          end;
      end
    else
      begin
        WriteLn(Com, 'No messages in this Area.');
        mult_cmds := False;
        Cmd_Queue := ''
      end;
    if (user_loc = 1) and (lread.message < TempLastRead[msg_offset]) then
      begin
        Assign(last_file, 'LASTREAD');
        Rewrite(last_file);
        lread.message := TempLastRead[msg_offset];
        Write(last_file, lread);
        Close(last_file);
        This := AreaBase;
        while (This <> nil) and (This^.AreaName <> AreaReq) do
          This := This^.next;
        if This <> nil then
          This^.AreaConf := This^.AreaConf or 8;
      end;
    SetSect(HomName);
    FreeMem(buffer, 2048)
  end;
  
end.                              { of NETREAD.PAS}

