{ TPBoard 4.2 Copyright (c) 1987,88 by Jon Schneider & Rick Petersen  
  Portions Copyright (c) 1986,87 by Steve Fox and Les Archambault  
  
  Last modified  ::  6-1-88 2:41 pm 
}

{$R-}                             {Range checking off}
{$B-}                             {Boolean complete evaluation off}
{$S-}                             {Stack checking off}
{$I+}                             {I/O checking on}
{$N-}                             {No numeric coprocessor}

Unit Sysop4;

Interface

Uses
  TPCrt, Dos, Globals, TAccess, Core1, Core2,
  TPSTRING, Dirs, MsgMove, MsgRead, Sysop1;
  
  
procedure print_log;

procedure toggle_audit;

procedure delete_file;

procedure copy_file;

procedure rename_file;

procedure file_status;



  {==========================================================================}
  
  
Implementation


  procedure print_log;
    { Print the log file }
    
  const
    txt_act         : array
    {.F-}
    [0..19] of DosFileName = ('TP-B up  ', 'TP-B down', 'Login    ', 'Logout   ',
                              'Recv-Xmdm', 'Send-Xmdm', 'Type-file', 'Complete ',
                              'Failed   ', 'New User ', 'Error    ', 'Purge    ',
                              'Car. Lost', 'Inp Tmout', 'Canceled ', 'Send-Zmdm',
                              'Recv-Zmdm', 'Send-Gmdm', 'Recv-Gmdm', 'Twit     ');
  {.F+}
  var
    t               : tad_array;
    Str             : StrTAD;
    line_count,
    rec             : Integer;
    temp_user_rec   : user_list;
    
  begin
    abort := False;
    SetSect(HomName);
    GetTAD(t);
    Str := FormTAD(t);
    WriteLn(Com, 'Log file as of: ', Str);
    WriteLn(Com);
    line_count := 2;
    if audit_on then
      begin
        SetSect(AudName);
        WriteLn(AuditFile, 'Log file as of: ', Str);
        WriteLn(AuditFile);
        SetSect(HomName);
      end;
    rec := Pred(FileSize(logr_file));
    if rec > 1 then
      with logr_rec do
        begin
          Seek(logr_file, rec);
          while (not brk) and Online and (rec > 0) do
            begin
              Read(logr_file, logr_rec);
              if (action > 1) and (logr_rec.user > 0) and (logr_rec.user <= (FileLen(
                DatF))) then
                begin
                  GetRec(DatF, logr_rec.user, temp_user_rec);
                  if temp_user_rec.used <> 0 then
                    begin
                      temp_user_rec.fn := 'Deleted';
                      temp_user_rec.ln := 'User';
                    end;
                end
              else
                begin
                  if action > 1 then
                    temp_user_rec.fn := 'Unknown'
                  else
                    temp_user_rec.fn := 'No';
                  temp_user_rec.ln := 'User';
                end;
              if (action > 19) or (action < 0) then
                action := 10;     {error}
              Str := FormTAD(date);
              WriteLn(Com, pad(Str, 28), txt_act[action], ' ', pad(temp_user_rec.fn+' '
                +temp_user_rec.ln,
                Succ(len_name)), Text);
              if (not printer_copy) and (not audit_on) and (user_rec.lines <> 99) then
                begin
                  Inc(line_count);
                  if line_count >= user_rec.lines then
                    begin
                      pause;
                      line_count := 1;
                    end;
                end;
              if audit_on then
                begin
                  SetSect(AudName);
                  WriteLn(AuditFile, pad(Str, 28), txt_act[action], ' ', pad(
                    temp_user_rec.fn+' '+temp_user_rec.
                    ln, Succ(len_name)), Text);
                  SetSect(HomName);
                end;
              rec := Pred(rec);
              Seek(logr_file, rec);
            end;                  {while rec>0}
        end;
    if (not printer_copy) and (not audit_on) and (line_count > 1) then
      pause;
  end;
  
  
  
  procedure toggle_audit;
    { Turn the audit trail on and off }
    
  var
    i, ext, space   : Integer;
    t               : tad_array;
    AuditName       : StrPr;
    sect_name       : DosFileName;
    done, newfile   : Boolean;
    This            : SectPtr;
    
  begin
    if audit_on then
      begin
        SetSect(AudName);
        {$I-}
        Close(AuditFile); {$I+}
        if IoResult = 0 then
          WriteLn(Com, 'Audit file closed.')
        else
          WriteLn(Com, 'Audit file problem. Audit OFF.');
        audit_on := False;
        SetSect(HomName);
      end
    else
      begin
        done := False;
        This := SectBase;         {get section name where auditfile will be}
        while (This <> nil) and (This^.SectDrive <> AudDrv[1]) and (Pos(This^.SectName, AudName
          ) = 0) do
          This := This^.next;
        if (This^.SectDrive = AudDrv[1]) and (Pos(This^.SectName, AudName) > 0) then
          sect_name := This^.SectName
        else
          begin
            sect_name := 'SYSTEM';
            AudDrv := HomDrv;
            AudName := HomName;
          end;
        repeat
          WriteLn(Com);
          Write(Com, 'Audit File will be written to Section: ', sect_name, ' ');
          done := (not ask('Change it', 'N'));
          if (not done) then
            begin
              WriteLn(Com);
              SetSect(HomName);
              sect_name := get_section_name(' ');
              This := SectBase;
              while (This <> nil) and (This^.SectName <> sect_name) do
                This := This^.next;
              if This^.SectName = sect_name then
                begin
                  AudDrv := This^.SectDrive+':\';
                  if (Length(HomName) > 3) and (AudDrv = HomDrv) then
                    AudName := AudDrv+Copy(HomName, 4, Length(HomName))+'\';
                  AudName := AudName+This^.SectName;
                end
              else
                begin
                  AudDrv := HomDrv;
                  AudName := HomName;
                end;
            end;
        until (not Online) or done;
        GetTAD(t);
        ext := 0;
        SetSect(AudName);
        repeat
          AuditName := intstr(t[4], 2)+'-'+intstr(t[3], 2)+'-'+intstr(t[5], 2)+'.'+intstr(ext,
            3);
          for i := 1 to Length(AuditName) do
            if AuditName[i] = ' ' then
              AuditName[i] := '0';
          Assign(AuditFile, AuditName);
          {$I-}
          Reset(AuditFile) {$I+} ; { Make sure it's a new file }
          newfile := (IoResult <> 0);
          if not newfile then
            Close(AuditFile);
          Inc(ext)
        until newfile;
        Rewrite(AuditFile);
        SetSect(HomName);
        space := (diskfree(Ord(Upcase(AudDrv[1]))-64) div 1024);
        WriteLn(Com, 'Audit file, ', AuditName, ', ready.');
        WriteLn(Com, 'There is currently ', space, 'K space available for the audit file.');
        WriteLn(Com, 'No further disk space checking will be performed.');
        WriteLn(Com);
        audit_on := True
      end
  end;
  
  
  procedure delete_file;
    { Delete file from disk }
    
  var
    DelName         : DosFileName;
    DelFile         : file;
    
  begin
    if ((not in_library) and (not in_arc)) and ((user_rec.access >= 250) or (not remote_copy))
    then
      begin
        DelName := correct_fn(prompt('Name of file to delete', 12, 'ES'));
        if (DelName <> '') and (DelName <> ' ') then
          begin
            Assign(DelFile, DelName);
            SetSect(SetName);
            {$I-}
            Reset(DelFile) {$I+} ; { Ensure file exists }
            OK := (IoResult = 0);
            if OK then
              begin
                if ask('Are you sure', 'Y') then
                  begin
                    Close(DelFile);
                    Erase(DelFile);
                    WriteLn(Com, DelName, ' deleted.')
                  end
              end
            else
              begin
                WriteLn(Com, DelName, ' not found.');
              end;
          end;
        SetSect(HomName);
        ReadDir(DirEntries, DirSpace, DirBase);
      end
    else
      begin
        if in_library then
          WriteLn(Com, 'Can not Delete in Library file.');
        if in_arc then
          WriteLn(Com, 'Can not Delete in ARC file.');
      end;
  end;
  
  
  
  procedure copy_file;
    { Copy file from one file area to another }
    
  var
    DstDrv          : Str3;
    DstSect,
    SrcName         : DosFileName;
    SrcFile,
    DstFile         : file;
    Dirspec         : StrPr;
    Buf             : ^Byte;
    BufferSize      : LongInt;
    
    procedure do_copy;
    
    var
      Num, N          : Word;
      
    begin
      while OK and (not EOF(SrcFile)) do
        begin
          SetSect(SetName);
          {$I-}
          BlockRead(SrcFile, Buf^, BufferSize, Num) {$I+} ;
          OK := (IoResult = 0);
          if OK then
            begin
              SetSect(Dirspec);
              {$I-}
              BlockWrite(DstFile, Buf^, Num, N) {$I+} ;
              OK := (IoResult = 0);
              if not OK then
                WriteLn(Com, 'Write failed.')
            end
          else
            WriteLn(Com, 'Read failed.')
        end
    end;
    
  begin                           { copy_file }
    if ((not in_library) and (not in_arc)) and ((user_rec.access >= 250) or (not remote_copy))
    then
      begin
        BufferSize := MaxAvail;
        if BufferSize > 65521 then
          BufferSize := 65521;
        GetMem(Buf, BufferSize);
        SrcName := correct_fn(prompt('Name of file to copy', 12, 'ES'));
        Assign(SrcFile, SrcName);
        SetSect(SetName);
        {$I-}
        Reset(SrcFile, 1) {$I+} ; { Ensure file exists }
        OK := (IoResult = 0);
        if OK then
          begin
            SetSect(HomName);
            Write(Com, 'Copy to: ');
            DstSect := get_section_name(' ');
            SetSect(SetName);
            FindSect(DstSect, DstDrv, OK);
            if OK then
              begin
                Assign(DstFile, SrcName);
                if DstSect = 'SYSTEM' then
                  Dirspec := HomName
                else
                  begin
                    Dirspec := DstDrv;
                    if (Length(HomName) > 3) and (Dirspec = HomDrv) then
                      begin
                        Dirspec := Dirspec+Copy(HomName, 4, Length(HomName));
                        Dirspec := Dirspec+'\';
                      end;
                    if Pos(':', DstSect) = 2 then
                      Dirspec := Dirspec+Copy(DstSect, 3, Length(DstSect))
                    else
                      Dirspec := Dirspec+DstSect;
                  end;
                SetSect(Dirspec);
                {$I-}
                Reset(DstFile) {$I+} ; { Ensure file doesn't already exist }
                OK := (IoResult <> 0);
                if OK then
                  begin
                    {$I-}
                    Rewrite(DstFile, 1) {$I+} ;
                    OK := (IoResult = 0);
                    if OK then
                      begin
                        do_copy;
                        SetSect(Dirspec);
                        {$I-}
                        Close(DstFile) {$I+} ;
                        OK := OK and (IoResult = 0);
                        SetSect(SetName);
                        Close(SrcFile);
                        if OK then
                          begin
                            WriteLn(Com, SrcName, ' successfully copied.');
                            if ask('Delete original file', 'Y') then
                              begin
                                Erase(SrcFile);
                                WriteLn(Com, 'Original file deleted.')
                              end
                            else
                              WriteLn(Com, 'Original file retained.')
                          end
                        else
                          begin
                            SetSect(Dirspec);
                            Close(DstFile);
                            Erase(DstFile);
                            WriteLn(Com, 'Copy failed.  Partial file deleted.')
                          end
                      end
                    else
                      WriteLn(Com, 'Cannot create file in destination area.')
                  end
                else
                  WriteLn(Com, 'File already exists in destination area.')
              end
            else
              WriteLn(Com, 'Destination section ', DstSect, ' not found.')
          end
        else
          WriteLn(Com, 'File ', SrcName, ' not found.');
        {$I-}
        Close(DstFile);
        Close(SrcFile); {$I+}
        FreeMem(Buf, BufferSize);
        SetSect(HomName);
        ReadDir(DirEntries, DirSpace, DirBase);
      end
    else
      begin
        if in_library then
          WriteLn(Com, 'Copying not allowed in Library file.');
        if in_arc then
          WriteLn(Com, 'Copying not allowed in Arc file.');
      end;
  end;
  
  
  
  procedure rename_file;
  
  var
    oldname,
    newname         : DosFileName;
    newfile,
    oldfile         : file;
    
  begin
    if ((not in_library) and (not in_arc)) and ((user_rec.access >= 250) or (not remote_copy))
    then
      begin
        WriteLn(Com);
        oldname := correct_fn(prompt('Old File Name', 12, 'ES'));
        if oldname <> ' ' then
          begin
            Assign(oldfile, oldname);
            SetSect(SetName);
            {$I-}
            Reset(oldfile); {$I+}
            OK := (IoResult = 0);
            SetSect(HomName);
            if OK then
              begin
                newname := correct_fn(prompt('New File Name', 12, 'ES'));
                if newname <> ' ' then
                  begin
                    Assign(newfile, newname);
                    SetSect(SetName);
                    {$I-}
                    Reset(newfile); {$I+}
                    OK := (IoResult <> 0);
                    if OK then
                      begin
                        Rename(oldfile, newname);
                        WriteLn(Com, 'File Renamed');
                      end
                    else
                      WriteLn(Com, newname, ' already exists.');
                  end
                else
                  WriteLn(Com, oldname, ' not found.');
              end;
          end;
        {$I-}
        Close(oldfile);
        Close(newfile); {$I+}
        SetSect(HomName);
        ReadDir(DirEntries, DirSpace, DirBase);
      end
    else
      begin
        if in_library then
          WriteLn(Com, 'Renaming not allowed in Library file.');
        if in_arc then
          WriteLn(Com, 'Renaming not allowed in Arc file.');
      end;
  end;
  
  
  
  procedure file_status;
  
  var
    i               : Integer;
    Regs            : Dos.Registers;
    fname           : DosFileName;
    work            : string[13];
    status          : record_status;
    
  begin
    if ((not in_library) and (not in_arc)) and ((user_rec.access >= 250) or (not remote_copy))
    then
      begin
        WriteLn(Com);
        fname := correct_fn(prompt('Filename', 12, 'ES'));
        if fname <> '' then
          begin
            SetSect(SetName);
            work := fname+Chr(0);
            Regs.AX := $4300;     {get attribute}
            Regs.DS := Seg(work);
            Regs.DX := Ofs(work[1]);
            MsDos(Regs);          { call function }
            if (Regs.AX <> 2) and (Regs.AX <> 3) and (Regs.AX <> 5) then
              begin
                i := Lo(Regs.CX);
                if test_bit(i, 1) then
                  status := private {hidden}
                else
                  status := public;
                Write(Com, 'File ', fname, ' is ');
                if status = public then
                  WriteLn(Com, 'visible.')
                else
                  WriteLn(Com, 'invisible.');
                WriteLn(Com);
                if ask('Do you want to change status', 'Y') then
                  begin
                    SetSect(HomName);
                    if status = private then
                      status := public
                    else if status = public then
                      status := private;
                    hide_release(fname, status, SetName);
                    SetSect(HomName);
                    ReadDir(DirEntries, DirSpace, DirBase);
                  end;
              end
            else
              begin
                if Regs.AX = 2 then
                  WriteLn(Com, fname, ' not found.');
                if Regs.AX = 3 then
                  WriteLn(Com, 'path not found.');
                if Regs.AX = 5 then
                  WriteLn(Com, 'Access denied by DOS.');
              end;
            SetSect(HomName);
          end;                    {fname<>''}
        SetSect(HomName);
        ReadDir(DirEntries, DirSpace, DirBase);
      end                         {not in library}
    else
      begin
        if in_library then
          WriteLn(Com, 'Status change not allowed in Library file.');
        if in_arc then
          WriteLn(Com, 'Status change not allowed in Arc file.');
      end;
  end;
  
  
end.                              { of SYSOP4.PAS}


