
(*
 * Copyright 1987, 1989 Samuel H. Smith;  All rights reserved
 *
 * This is a component of the ProDoor System.
 * Do not distribute modified versions without my permission.
 * Do not remove or alter this notice or any other copyright notice.
 * If you use this in your own program you must distribute source code.
 * Do not use any of this in a commercial product.
 *
 *)

(*
 * Top level unit for the Tool Shop Tools Library
 *
 *)

{$i prodef.inc}

unit Tools;

interface

   uses Dos, MDosIO, OpenShare;

   {$I g:\tinc\anystring.inc}  (* general string declaration *)
   {$I g:\tinc\givetime.int}   (* give up time under doubledos *)
   {$I g:\tinc\ftoa.int}       (* float to ascii conversion *)
   {$I g:\tinc\atof.int}       (* ascii to float conversion *)
   {$I g:\tinc\atoi.int}       (* ascii to integer conversion *)
   {$I g:\tinc\itoa1.int}      (* integer to ascii conversion *)
   {$I g:\tinc\stof.int}       (* basic single to floating conversion *)
   {$I g:\tinc\stoa.int}       (* single to ascii conversion *)
   {$I g:\tinc\dtof.int}       (* basic double to floating conversion *)
   {$I g:\tinc\itoh.int}       (* integer to hex conversion *)
   {$I g:\tinc\itou.int}       (* integer to unsigned-real conversion *)
   {$I g:\tinc\ltor.int}       (* long-integer to real conversion *)
   {$I g:\tinc\rempath.int}    (* remove/manipulate filename paths *)
   {$I g:\tinc\iswild.int}     (* is a filename a wildcard? *)
   {$I g:\tinc\stoupper.int}   (* map string to upper case *)
   {$I g:\tinc\filesize.int}   (* get size of a file *)
   {$I g:\tinc\pattern.int}    (* wildcard filename pattern comparison *)
   {$I g:\tinc\sysdate2.int}   (* get system time string formats, mm-dd-yy & hh:mm *)
   {$I g:\tinc\gettime.int}    (* get system time in seconds *)
   {$I g:\tinc\delay.int}      (* delay function based on give-up-time and gettime *)
   {$I g:\tinc\delspace.int}   (* delete all spaces from a string *)
   {$I g:\tinc\replstr.int}    (* perform string replacements *)
   {$I g:\tinc\getenv.int}     (* get environment variables *)
   {$I g:\tinc\varstr.int}     (* variable allocation string library *)
   {$I g:\tinc\getfile3.int}   (* expand wildcard file lists *)
   {$I g:\tinc\ljust.int}      (* left justify strings *)
   {$I g:\tinc\bitmap.int}     (* manipulate bit maps *)
   {$I g:\tinc\flags.int}      (* manipulate bit flags *)
   {$I g:\tinc\appendc.int}    (* append character to string *)


implementation

   {$I g:\tinc\givetime.inc}   (* give up time under doubledos *)
   {$I g:\tinc\ftoa.inc}       (* float to ascii conversion *)
   {$I g:\tinc\atof.inc}       (* ascii to float conversion *)
   {$I g:\tinc\atoi.inc}       (* ascii to integer conversion *)
   {$I g:\tinc\itoa1.inc}      (* integer to ascii conversion *)
   {$I g:\tinc\stof.inc}       (* basic single to floating conversion *)
   {$I g:\tinc\stoa.inc}       (* single to ascii conversion *)
   {$I g:\tinc\dtof.inc}       (* basic double to floating conversion *)
   {$I g:\tinc\itoh.inc}       (* integer to hex conversion *)
   {$I g:\tinc\itou.inc}       (* integer to unsigned-real conversion *)
   {$I g:\tinc\ltor.inc}       (* long-integer to real conversion *)
   {$I g:\tinc\rempath.inc}    (* remove/manipulate filename paths *)
   {$I g:\tinc\iswild.inc}     (* is a filename a wildcard? *)
   {$I g:\tinc\stoupper.inc}   (* map string to upper case *)
   {$I g:\tinc\filesize.inc}   (* get size of a file *)
   {$I g:\tinc\pattern.inc}    (* wildcard filename pattern comparison *)
   {$I g:\tinc\getfile3.inc}   (* expand wildcard file lists *)
   {$I g:\tinc\sysdate2.inc}   (* get system time string formats, mm-dd-yy & hh:mm *)
   {$I g:\tinc\gettime.inc}    (* get system time in seconds *)
   {$I g:\tinc\delay.inc}      (* delay function based on give-up-time and gettime *)
   {$I g:\tinc\delspace.inc}   (* delete all spaces from a string *)
   {$I g:\tinc\replstr.inc}    (* perform string replacements *)
   {$I g:\tinc\getenv.inc}     (* get environment variables *)
   {$I g:\tinc\varstr.inc}     (* variable allocation string library *)
   {$I g:\tinc\ljust.inc}      (* left justify strings *)
   {$I g:\tinc\bitmap.inc}     (* manipulate bit maps *)
   {$I g:\tinc\flags.inc}      (* manipulate bit flags *)
   {$I g:\tinc\appendc.inc}    (* append character to string *)


begin
   fillchar(filetable,sizeof(filetable),0);
end.

